# include "hmg.ch"



function main
public loanreportcreated := .f.
public fdreportcreated := .f.
public rdreportcreated := .f.
public termarr := {"Months","Quarters","Half Years", "Years"}
public repayarr1 := {12,4,2,1}
public intarr := {"Monthly","Quarterly","Half yearly","Yearly"}
public intarr1 := {12,4,2,1}

public stdate := date()
public enddate := date()
public initrate := .12
public months := {"January","February","March","April","May","June","July","August","September","October","November","December"}
public interestcr := .f.
public intdates := {}
public acarr := {}
public acarr1 := {}
public resultarr := {}
public acarr2 := {}
public intratearr := {}
public prodarr := {}
public filename := ""
aadd(intratearr,{stdate,enddate,initrate})
public compounding := {"Monthly","Quarterly","Half yearly","Annually"}

hmg3(.t.)

set date ital
// SET navigation extended
// SET helpfile TO "interest.hlp"
set century on



define window interest at 0,0 width 800 height 600 title "Interest(ing) Calculator 3.0" icon "interest" main nosize nomaximize //helpbutton
   define tab section at 10,10 width 780 height 530 font "Arial" size 10 on change pagechanged()
      define page "&Loan"
         define image image1
            row 90
            col 25
            picture "loan"
            width 150
            height 120
         end image
         define label page1title
            row 30
            col 200
            fontname "Times New Roman"
            fontsize 24
            transparent .t.
            value "Loan Section"
            height 60
            width 250
            fontcolor {255,0,0}
            fontbold .t.
         end label
         define label loanresult
            row 30
            col 450
            fontname "Times New Roman"
            fontsize 18
            transparent .t.
            value ""
            width 300
            fontcolor {255,0,0}
            fontbold .t.
         end label
         define label lintcomp
            row 90
            col 200
            value "Interest Compounding"
            transparent .t.
            width 150
         end label
         define combobox cintcomp
            row 90
            col 370
            items intarr
            helpid 8
            width 150
            value 1
            tooltip "Change the Periodicity of Compounding the interest here."
         end combobox
         define textbox tprincipal
            row 120
            col 370
            value 0.0
            Numeric .t.
            inputmask "9999999999.99"
            helpid 2
            rightalign .t.
            width 150
            tooltip "Enter the Principal amount here."
         end textbox
         define textbox tintrate
            row 150
            col 370
            value 0.0
            Numeric .t.
            inputmask "999.99"
            helpid 3
            tooltip "Enter the Rate of Interest here."
            rightalign .t.
            width 150
         end textbox
         define label lpercent
            row 150
            col 530
            value "% per annum"
            transparent .t.
            width 100
         end label
         define textbox tterm
            row 180
            col 370
            value 0
            Numeric .t.
            helpid 4
            tooltip "Enter the Term of the Loan here."
            rightalign .t.
            width 150
         end textbox
         define combobox cterm
            row 180
            col 530
            items termarr
            tooltip "Enter the Frequency of repayment here."
            width 100
            value 1
         end combobox
         define textbox tinstalment
            row 210
            col 370
            value 0.0
            Numeric .t.
            inputmask "9999999999.99"
            tooltip "Enter the Amount of instalment here."
            helpid 5
            rightalign .t.
            width 150
            onlostfocus loanreview()
         end textbox
         define button bprincipal
            row  120
            col 200
            caption "&Principal"
            width 150
            fontname "Arial"
            fontsize 12
            action principalcalculate()
            tooltip "Click Here to findout Principal Amount (Alt+P)"
         end button
         define button bintrate
            row  150
            col 200
            caption "In&terest Rate"
            width 150
            tooltip "Click Here to findout the Interest Rate (Alt+T)"
            fontname "Arial"
            fontsize 12
            action intratecalculate()
         end button
         define button bterm
            row  180
            col 200
            caption "Ter&m"
            width 150
            fontname "Arial"
            tooltip "Click Here to findout the Term of the Loan (Alt+M)"
            fontsize 12
            action termcalculate()
         end button
         define button binstalment
            row  210
            col 200
            caption "&Instalment"
            width 150
            tooltip "Click Here to findout the Instalment Amount (Alt+I)"
            fontname "Arial"
            fontsize 12
            action instalmentcalculate()
         end button
         define grid loanaccount
            row 250
            col 30
            width 670
            height 240
            headers {"     ","Opening Balance","Interest Charged","Repayment","Closing Balance"}
            widths {80,140,140,140,140}
            fontbold .t.
            backcolor {255,200,200}
            justify {0,1,1,1,1}
         end grid
         DEFINE label total
            Row 490
            Col 50
            width 50
            transparent .t.
            value "Total"
         END label
         DEFINE textbox totalinterest
            Row 490
            Col 250
            width 140
            rightalign .t.
            inputmask "9999999999.99"
            numeric .t.
            value 0.0
            tabstop .f.
            readonly .t.
         END textbox
         DEFINE textbox totalrepayment
            Row 490
            Col 390
            width 140
            rightalign .t.
            inputmask "9999999999.99"
            numeric .t.
            value 0.0
            tabstop .f.
            readonly .t.
         END textbox
         define button loanxl
            row 300
            col 720
            picture "excel"
            width 32
            height 32
            tooltip "Click here to Export the Contents to Excel"
            action loanexportxl()
         end button
         define button loanreport
            row 350
            col 720
            picture "text"
            width 32
            height 32
            tooltip "Click Here to Show the Report in text file"
            action interestreport()
         end button
         define button loanprint
            row 400
            col 720
            picture "print1"
            width 32
            height 32
            tooltip "Click here to Print the report"
            action loanrepprint()
         end button
         define button loanreset
            row 460
            col 720
            caption "&Clear"
            width 40
            tooltip "Click here to Reset the figures (Alt+C)"
            tabstop .f.
            action resetfigures()
         end button
      END page
      define page "&Fixed Deposit"
         define image image2
            row 90
            col 25
            picture "fixeddep"
            width 150
            height 120
         end image
         define label page2title
            row 30
            col 100
            fontname "Times New Roman"
            fontsize 24
            transparent .t.
            value "Fixed Deposit Section"
            height 60
            width 350
            fontcolor {50,100,50}
            fontbold .t.
         end label
         define label fdresult
            row 30
            col 450
            fontname "Times New Roman"
            fontsize 18
            transparent .t.
            value ""
            width 300
            fontcolor {50,100,50}
            fontbold .t.
         end label
         define label depintcomp
            row 90
            col 200
            width 150
            transparent .t.
            value "Interest Compounding"
         end label
         define combobox depositintcomp
            row 90
            col 370
            helpid 8
            items {"Daily","Monthly","Quarterly","Half-yearly","Yearly"}
            tooltip "Change the Periodicity of Compounding the interest here."
            width 150
            value 2
         end combobox
         define textbox initialdeposit
            row 120
            col 370
            value 0.0
            Numeric .t.
            width 150
            helpid 2
            tooltip "Enter the Initial Deposit amount here."
            inputmask "9999999999.99"
            rightalign .t.
         end textbox
         define textbox depositinterest
            row 150
            col 370
            value 0.0
            width 150
            Numeric .t.
            helpid 3
            tooltip "Enter the Rate of Interest here."
            inputmask "999.99"
            rightalign .t.
         end textbox
         define label ldpercent
            row 150
            col 530
            value "% per annum"
            transparent .t.
            width 100
         end label
         define textbox depositperiod
            row 180
            col 370
            value 0
            helpid 4
            tooltip "Enter the Term of the Fixed Deposit here."
            Numeric .t.
            rightalign .t.
            width 150
         end textbox
         define combobox depositinterval
            row 180
            col 530
            width 100
            items {"Days","Months","Quarters","Half-years","Years"}
            value 2
         end combobox
         define textbox depositmaturity
            row 210
            col 370
            value 0.0
            Numeric .t.
            width 150
            helpid 6
            tooltip "Enter the Maturity Value of the Fixed Deposit here."
            inputmask "9999999999.99"
            rightalign .t.
         end textbox
         define button dinitial
            row 120
            col 200
            caption "De&posit Amount"
            tooltip "Click Here to findout Initial Deposit Amount (Alt+P)"
            width 150
            fontname "Arial"
            fontsize 12
            action depositinitial()
         end button
         define button dintrate
            row 150
            col 200
            caption "In&terest Rate"
            width 150
            tooltip "Click Here to findout the Interest Rate (Alt+T)"
            fontname "Arial"
            fontsize 12
            action depositintrate()
         end button
         define button dperiod
            row 180
            col 200
            caption "Ter&m"
            width 150
            tooltip "Click Here to findout the Term of the Fixed Deposit (Alt+M)"
            fontname "Arial"
            fontsize 12
            action depositperiod()
         end button
         define button dmaturity
            row 210
            col 200
            caption "Matur&ity Value"
            tooltip "Click Here to findout the Maturity value (Alt+I)"
            action depmaturity()
            fontname "Arial"
            fontsize 12
            width 150
         end button
         define grid fixeddepositaccount
            row 250
            col 30
            width 670
            height 240
            headers {"     ","Opening Balance","Interest","Closing Balance"}
            widths {120,160,160,160}
            justify {0,1,1,1}
            fontbold .t.
            backcolor {200,255,200}
         end grid
         DEFINE label fdtotal
            Row 490
            Col 50
            width 50
            transparent .t.
            value "Total"
         END label
         DEFINE textbox fdtotalinterest
            Row 490
            Col 310
            width 160
            value 0.0
            rightalign .t.
            inputmask "9999999999.99"
            numeric .t.
            tabstop .f.
            readonly .t.
         END textbox
         define button fdxl
            row 300
            col 720
            picture "excel"
            width 32
            height 32
            tooltip "Click here to Export the Contents to Excel"
            action fdexportxl()
         end button
         define button fixeddepositreport
            row 350
            col 720
            picture "text"
            width 32
            height 32
            tooltip "Click Here to Show the Report in text file"
            action fixeddeposittextreport()
         end button
         define button fdprint
            row 400
            col 720
            picture "print1"
            width 32
            height 32
            tooltip "Click here to Print the report"
            action fdrepprint()
         end button
         define button fdreset
            row 460
            col 720
            caption "&Clear"
            width 40
            tooltip "Click here to Reset the figures (Alt+C)"
            tabstop .f.
            action resetfigures()
         end button
      end page
      define page "&Recurring Deposit"
         define image image3
            row 90
            col 25
            picture "recur"
            width 150
            height 120
         end image
         define label page3title
            row 30
            col 50
            fontname "Times New Roman"
            transparent .t.
            fontsize 24
            value "Recurring Deposit Section"
            height 60
            width 400
            fontcolor {0,0,255}
            fontbold .t.
         end label
         define label rdresult
            row 30
            col 450
            fontname "Times New Roman"
            fontsize 18
            transparent .t.
            value ""
            width 300
            fontcolor {0,0,255}
            fontbold .t.
         end label
         define label rdepintcomp
            row 90
            col 200
            width 150
            transparent .t.
            value "Interest Compounding"
         end label
         define combobox rdepositintcomp
            row 90
            col 370
            tooltip "Change the Periodicity of Compounding the interest here."
            items {"Daily","Monthly","Quarterly","Half-yearly","Yearly"}
            helpid 8
            width 150
            value 2
         end combobox
         define textbox rdinstalment
            row 120
            col 370
            value 0.0
            Numeric .t.
            helpid 2
            width 150
            inputmask "9999999999.99"
            tooltip "Enter the Instalment amount here."
            rightalign .t.
         end textbox
         define textbox rdepositinterest
            row 150
            col 370
            value 0.0
            helpid 3
            width 150
            Numeric .t.
            inputmask "999.99"
            tooltip "Enter the Rate of Interest here."
            rightalign .t.
         end textbox
         define label rdpercent
            row 150
            col 530
            transparent .t.
            value "% per annum"
            width 100
         end label
         define textbox rdepositperiod
            row 180
            col 370
            value 0
            Numeric .t.
            helpid 4
            rightalign .t.
            tooltip "Enter the Term of the Recurring Deposit here."
            width 150
         end textbox
         define combobox rdepositinterval
            row 180
            col 530
            width 100
            items {"Days","Months","Quarters","Half-years","Years"}
            value 2
         end combobox
         define textbox rdepositmaturity
            row 210
            col 370
            value 0.0
            Numeric .t.
            width 150
            helpid 6
            inputmask "9999999999.99"
            tooltip "Enter the Maturity Value here."
            rightalign .t.
         end textbox
         define button rdinstal
            row 120
            col 200
            caption "De&posit Amount"
            tooltip "Click Here to findout Periodical Deposit Amount (Alt+P)"
            fontname "Arial"
            fontsize 12
            width 150
            action rdepositinstal()
         end button
         define button rdintrate
            row 150
            col 200
            caption "In&terest Rate"
            width 150
            action rdepositintrate()
            tooltip "Click Here to findout the Interest Rate (Alt+T)"
            fontname "Arial"
            fontsize 12
         end button
         define button rdperiod
            row 180
            col 200
            caption "Ter&m"
            tooltip "Click Here to findout the Number of instalments of the Recurring Deposit (Alt+M)"
            fontname "Arial"
            fontsize 12
            width 150
            action rdepositperiod()
         end button
         define button rdmaturity
            row 210
            col 200
            caption "Matur&ity Value"
            tooltip "Click Here to findout the Maturity Amount (Alt+I)"
            fontname "Arial"
            fontsize 12
            action rdepmaturity()
            width 150
         end button
         define grid recurdepositaccount
            row 250
            col 30
            width 670
            height 240
            headers {"     ","Opening Balance","Investment","Total","Interest","Closing Balance"}
            widths {60,120,120,120,120,120}
            justify {0,1,1,1,1,1}
            fontbold .t.
            backcolor {200,200,255}
         end grid
         DEFINE label rdtotal
            Row 490
            Col 50
            width 50
            transparent .t.
            value "Total"
         END label
         DEFINE textbox rdtotalinvestment
            Row 490
            Col 210
            width 120
            value 0.0
            rightalign .t.
            numeric .t.
            inputmask "9999999999.99"
            tabstop .f.
            readonly .t.
         END textbox
         DEFINE textbox rdtotalinterest
            Row 490
            Col 450
            width 120
            rightalign .t.
            value 0.0
            numeric .t.
            inputmask "9999999999.99"
            tabstop .f.
            readonly .t.
         END textbox
         define button rdxl
            row 300
            col 720
            picture "excel"
            width 32
            height 32
            tooltip "Click here to Export the Contents to Excel"
            action rdexportxl()
         end button
         define button recurdepositreport
            row 350
            col 720
            picture "text"
            width 32
            height 32
            tooltip "Click Here to Show the Report in text file"
            action recurdeposittextreport()
         end button
         define button rdprint
            row 400
            col 720
            picture "print1"
            width 32
            height 32
            tooltip "Click here to Print the report"
            action rdrepprint()
         end button
         define button rdreset
            row 460
            col 720
            caption "&Clear"
            width 40
            tooltip "Click here to Reset the figures (Alt+C)"
            tabstop .f.
            action resetfigures()
         end button
      end page
      define page "&Reserve"
         define image rimage1
            row 50
            col 25
            picture "loan"
            width 150
            height 120
         end image
         define label rpage1title
            row 30
            col 200
            fontname "Times New Roman"
            fontsize 24
            transparent .t.
            value "Reserve"
            height 60
            width 250
            fontcolor {255,0,0}
            fontbold .t.
         end label
         define label rloanresult
            row 30
            col 450
            fontname "Times New Roman"
            fontsize 18
            transparent .t.
            value ""
            width 300
            fontcolor {255,0,0}
            fontbold .t.
         end label
         define label rlintcomp
            row 90
            col 200
            value "Interest Compounding"
            transparent .t.
            width 150
         end label
         define combobox rcintcomp
            row 90
            col 370
            items intarr
            helpid 8
            width 150
            value 1
            tooltip "Change the Periodicity of Compounding the interest here."
         end combobox
         define textbox rtprincipal
            row 120
            col 370
            value 0.0
            Numeric .t.
            inputmask "9999999999.99"
            helpid 2
            rightalign .t.
            width 150
            tooltip "Enter the Principal amount here."
         end textbox
         define textbox rtintrate
            row 150
            col 370
            value 0.0
            Numeric .t.
            inputmask "999.99"
            helpid 3
            tooltip "Enter the Rate of Interest here."
            rightalign .t.
            width 150
         end textbox
         define label rlpercent
            row 150
            col 530
            value "% per annum"
            transparent .t.
            width 75
         end label
         DEFINE frame buyinglabel
            Row 130
            Col 610
            width 160
            caption "Buying Rate"
            height 50
         END frame
         DEFINE textbox buyrate
            Row 150
            Col 615
            width 100
            value 0.0
            Numeric .t.
            inputmask "999.99"
            helpid 3
            tooltip "Enter the Rate of Interest here."
            rightalign .t.
         end textbox
         DEFINE label resperlabel
            Row 150
            Col 720
            width 45
            value "% p.a."
         END label

         define textbox rtterm
            row 180
            col 370
            value 0
            Numeric .t.
            helpid 4
            tooltip "Enter the Term of the Loan here."
            rightalign .t.
            width 150
         end textbox
         define combobox rcterm
            row 180
            col 530
            items termarr
            tooltip "Enter the Frequency of repayment here."
            width 80
            value 1
         end combobox
         define textbox rtinstalment
            row 210
            col 370
            value 0.0
            Numeric .t.
            inputmask "9999999999.99"
            tooltip "Enter the Amount of instalment here."
            helpid 5
            rightalign .t.
            width 150
            onlostfocus rloanreview()
         end textbox
         DEFINE frame reserveframe
            Row 190
            Col 610
            width 160
            caption "Reserve"
            height 50
         END frame
         DEFINE textbox reserve
            Row 210
            Col 615
            value 0.0
            Numeric .t.
            inputmask "9999999999.99"
            rightalign .t.
            width 150
         end textbox
         define button rbprincipal
            row  120
            col 200
            caption "&Principal"
            width 150
            fontname "Arial"
            fontsize 12
            action rprincipalcalculate()
            tooltip "Click Here to findout Principal Amount (Alt+P)"
         end button
         define button rbintrate
            row  150
            col 200
            caption "&Selling Rate"
            width 150
            tooltip "Click Here to findout the Interest Rate (Alt+T)"
            fontname "Arial"
            fontsize 12
            action rintratecalculate()
         end button
         define button rbterm
            row  180
            col 200
            caption "Ter&m"
            width 150
            fontname "Arial"
            tooltip "Click Here to findout the Term of the Loan (Alt+M)"
            fontsize 12
            action rtermcalculate()
         end button
         define button rbinstalment
            row  210
            col 200
            caption "&Instalment"
            width 150
            tooltip "Click Here to findout the Instalment Amount (Alt+I)"
            fontname "Arial"
            fontsize 12
            action rinstalmentcalculate()
         end button
         DEFINE radiogroup resaccount
            Row 180
            Col 10
            width 150
            options {"In Selling Rate","In Buying Rate"}
            value 1
            height 35
         END radiogroup
         define grid rloanaccount
            row 250
            col 30
            width 670
            height 240
            headers {"     ","Opening Balance","Interest Charged","Repayment","Closing Balance"}
            widths {80,140,140,140,140}
            fontbold .t.
            backcolor {255,200,200}
            justify {0,1,1,1,1}
         end grid
         DEFINE label rtotal
            Row 490
            Col 50
            width 50
            transparent .t.
            value "Total"
         END label
         DEFINE textbox rtotalinterest
            Row 490
            Col 250
            width 140
            rightalign .t.
            inputmask "9999999999.99"
            numeric .t.
            value 0.0
            tabstop .f.
            readonly .t.
         END textbox
         DEFINE textbox rtotalrepayment
            Row 490
            Col 390
            width 140
            rightalign .t.
            inputmask "9999999999.99"
            numeric .t.
            value 0.0
            tabstop .f.
            readonly .t.
         END textbox
         define button rloanxl
            row 300
            col 720
            picture "excel"
            width 32
            height 32
            tooltip "Click here to Export the Contents to Excel"
            action rloanexportxl()
         end button
         define button rloanreport
            row 350
            col 720
            picture "text"
            width 32
            height 32
            tooltip "Click Here to Show the Report in text file"
            action rinterestreport()
         end button
         define button rloanprint
            row 400
            col 720
            picture "print1"
            width 32
            height 32
            tooltip "Click here to Print the report"
            action rloanrepprint()
         end button
         define button rloanreset
            row 460
            col 720
            caption "&Clear"
            width 40
            tooltip "Click here to Reset the figures (Alt+C)"
            tabstop .f.
            action resetfigures()
         end button
      END page
      define page "Current Account"
      
         define frame setframe
            row 25
            col 5
            width 770
            height 150
            caption "Settings"
         end frame
         DEFINE label startlabel
            Row 45
            Col 10
            value "From Date : (dd-mm-yyyy)"
            width 150
         END label
         DEFINE textbox stdate
            Row 45
            Col 160
            onlostfocus datechanged()
            value stdate
            date .t.
            width 100
         END textbox
         define label tolabel
            row 75
            col 10
            value "To Date : (dd-mm-yyyy)"
            width 150
         end label
         DEFINE textbox enddate
            Row 75
            Col 160
            readonly .t.
            tabstop .f.
            date .t.
            width 100
         END textbox
         DEFINE label compoundlabel
            Row 105
            Col 10
            value "Compounding :"
            width 150
         END label
         DEFINE combobox compoundsel
            Row 105
            Col 160
            items compounding
            value 1
            width 100
         END combobox
         DEFINE label intcrlabel1
            Row 135
            Col 10
            value "Interest for Credit bal."
            width 150
         END label
         define combobox intcr1
            row 135
            col 160
            value 1
            items {"No","Yes"}
            width 50
         end combobox   
         define label intstruct
            row 45
            col 280
            value "Interest Rate Structure During the year"
            width 320
         end label
         DEFINE grid interestgrid
            Row 70
            Col 280
            width 320
            height 100
            headers {"From","To","Int. Rate %"}
            widths {100,100,95}
            allowedit .t.
      //      cellnavigation .t.
            columncontrols {{"TEXTBOX","DATE"},{"TEXTBOX","DATE"},{"TEXTBOX","NUMERIC","99.99"}}
            justify {0,0,1}
            ongotfocus interestratekeyinit()
            onlostfocus interestratekeyrelease()
            columnwhen {{||.f.},{||.t.},{||.t.}}
            columnvalid {{||.t.},{||interesttodateverify()},{||interestrateverify()}}
         END grid
         define grid account
            row 180
            col 10
            width 450
            height 130
            widths {100,140,140,50}
            headers {"Date","Debit","Credit","Interest"}
            justify {0,1,1,0}
            allowedit .t.
      //      cellnavigation .t.
            columncontrols {{"TEXTBOX","DATE"},{"TEXTBOX","NUMERIC","99999999999.99"},{"TEXTBOX","NUMERIC","99999999999.99"},{"COMBOBOX",{"No","Yes"}}}
            columnwhen {{||.t.},{||.t.},{||.t.},{||.t.}}
            columnvalid {{||txndateverify()},{|| accountdebitverify()},{||accountcreditverify()},{||.t.}}
            ongotfocus accountkeyinit()
            onlostfocus accountkeyrelease()
         end grid
         define button calc
            row 180
            col 470
            width 32
            height 32
            picture "calc1"
            tooltip "Click here to Calculate"
            action finished()
         end button
         define button browse1
            row 180
            col 505
            picture "import"
            width 32
            height 32
            tooltip "Click here to import the Current account from a csv file"
            action importfromfile(getfile({{"Comma Separated Value Files (*.csv)","*.csv"},{"Excel Spreadsheet File (*.xls)","*.xls"}},"Open a Current Account file"),,.t.)
         end button
         define button saveaccount1
            row 180
            col 539
            width 32
            height 32
            picture "save1"
            action saveaccount1()
            tooltip "Click here to save the Current account to csv file"
         end button
         define button currentacprint 
            row 180
            col 573
            picture "print1"
            width 32
            height 32
            tooltip "Click here to Print the report"
            action currentacrepprint()
         end button
         define label oldrep
            row 240
            col 470
            width 300
            fontname "Arial"
            fontcolor {255,0,0}
         end label
         define label newrep
            row 270
            col 470
            width 300
            fontname "Arial"
            fontcolor {0,0,255}
         end label
         define grid product
            row 320
            col 10
            height 200
            width 750
            headers {"Date","Details","Debit","Credit","Balance","D/C","Days","Product","Cum. Product","Int. Rate","Total Interest"}
            widths {80,80,120,120,120,50,40,120,120,50,120}
            justify {0,0,1,1,1,0,1,1,1,1,1}
         end grid
      end page
      define page "&About"
         define image image4
            row 60
            col 140
            picture "splash"
            width 500
            height 300
         end image
         define label myaddress
            row 370
            col 140
            transparent .t.
            width 500
            value "By S. Rathinagiri,  52, N.P.S. Street, Sivakasi - 626 123. India"
            fontcolor {255,0,0}
            fontbold .t.
         end label
         define label acknowledge
            row 400
            col 140
            width 80
            value "Developed in:"
            transparent .t.
            fontcolor {0,0,255}
            fontbold .t.
         end label
         define hyperlink minigui
            row 400
            col 220
            width 400
            value alltrim(miniguiversion())
            address "http://harbourminigui.googlepages.com/"
            tooltip "Click here to go to http://harbourminigui.googlepages.com/"
            handcursor .t.
            transparent .t.
            fontcolor {0,0,255}
            fontbold .t.
         end hyperlink
         define label homepagelabel
            row 430
            col 140
            width 80
            value "Home Page:"
            transparent .t.
            fontcolor {0,0,255}
            fontbold .t.
         end label
         define hyperlink homepage
            row 430
            col 220
            width 400
            value "http://www.rathinagiri.in"
            address "http://www.rathinagiri.in"
            tooltip "Click here to go to the home page of Interest(ing) Calculator"
            handcursor .t.
            transparent .t.
            fontcolor {0,0,255}
            fontbold .t.
         end hyperlink
         define hyperlink homepage1
            row 460
            col 220
            width 400
            value "SourceForge Project Page"
            address "http://sourceforge.net/projects/intcalc/"
            tooltip "Click here to go to the project page of SourceForge"
            handcursor .t.
            transparent .t.
            fontcolor {0,0,255}
            fontbold .t.
         end hyperlink
         DEFINE label emaillabel
            row 500
            col 140
            value "Comments and Suggestions are WELCOME at:"
            width 300
            transparent .t.
            fontbold .t.
         END label
         DEFINE hyperlink email
            row 500
            col 440
            value "srgiri@dataone.in"
            transparent .t.
            width 200
            handcursor .t.
            address "srgiri@dataone.in"
            fontbold .t.
         END hyperlink
      end page
   end tab
   define statusBar font "Arial"
      statusitem ""
      statusitem "Assumptions : 30 days a month & 360 days a year." width 400
      date width 100
   end statusBar
end window
&& define window interestsplash at 0,0 width 500 height 300 topmost nocaption  on init splashlogo() on release interest.restore()
   && define image splash1
      && row 0
      && col 0
      && picture "splash" 
      && width 500
      && height 300
   && end image
&& end window
on key Escape of interest action interest.release()
on key alt+p of interest action shortcutprincipal()
on key alt+t of interest action shortcutinterestrate()
on key alt+m of interest action shortcutnumber()
on key alt+i of interest action shortcutinstalment()
on key alt+c of interest action resetfigures()
on key alt+l of interest action interest.section.value := 1
on key alt+f of interest action interest.section.value := 2
on key alt+r of interest action interest.section.value := 3
on key alt+a of interest action interest.section.value := 4
datechanged()
&& center window interestsplash
center window interest
&& activate window interestsplash,interest
activate window interest
RETURN nil

FUNCTION shortcutprincipal
DO CASE
   CASE interest.section.value == 1
      principalcalculate()
   CASE interest.section.value == 2
      depositinitial()
   CASE interest.section.value == 3
      rdepositinstal()
ENDCASE
RETURN nil

FUNCTION shortcutinterestrate
DO CASE
   CASE interest.section.value == 1
      intratecalculate()
   CASE interest.section.value == 2
      depositintrate()
   CASE interest.section.value == 3
      rdepositintrate()
ENDCASE
RETURN nil

FUNCTION shortcutnumber
DO CASE
   CASE interest.section.value == 1
      termcalculate()
   CASE interest.section.value == 2
      depositperiod()
   CASE interest.section.value == 3
      rdepositperiod()
ENDCASE
RETURN nil

FUNCTION shortcutinstalment
DO CASE
   CASE interest.section.value == 1
      instalmentcalculate()
   CASE interest.section.value == 2
      depmaturity()
   CASE interest.section.value == 3
      rdepmaturity()
ENDCASE
RETURN nil


FUNCTION resetfigures
DO CASE
   CASE interest.section.value == 1
      interest.tinstalment.fontcolor := {0,0,0}
      interest.tprincipal.fontcolor := {0,0,0}
      interest.tterm.fontcolor := {0,0,0}
      interest.tintrate.fontcolor := {0,0,0}
      interest.tinstalment.value := 0.0
      interest.tprincipal.value := 0.0
      interest.tterm.value := 0
      interest.tintrate.value := 0.0
      interest.loanresult.value := ""
      interest.loanaccount.deleteallitems()
      interest.tprincipal.setfocus
   CASE interest.section.value == 2
      interest.initialdeposit.fontcolor := {0,0,0}
      interest.depositinterest.fontcolor := {0,0,0}
      interest.depositperiod.fontcolor := {0,0,0}
      interest.depositmaturity.fontcolor := {0,0,0}
      interest.initialdeposit.value := 0.0
      interest.depositinterest.value := 0.0
      interest.depositperiod.value := 0
      interest.depositmaturity.value := 0.0
      interest.fdresult.value := ""
      interest.fixeddepositaccount.deleteallitems()
      interest.initialdeposit.setfocus
   CASE interest.section.value == 3
      interest.rdinstalment.fontcolor := {0,0,0}
      interest.rdepositinterest.fontcolor := {0,0,0}
      interest.rdepositperiod.fontcolor := {0,0,0}
      interest.rdepositmaturity.fontcolor := {0,0,0}
      interest.rdinstalment.value := 0.0
      interest.rdepositinterest.value := 0.0
      interest.rdepositperiod.value := 0
      interest.rdepositmaturity.value := 0.0
      interest.rdresult.value := ""
      interest.recurdepositaccount.deleteallitems()
      interest.rdinstalment.setfocus
   CASE interest.section.value == 4
      interest.rtinstalment.fontcolor := {0,0,0}
      interest.rtprincipal.fontcolor := {0,0,0}
      interest.rtterm.fontcolor := {0,0,0}
      interest.rtintrate.fontcolor := {0,0,0}
      interest.rtinstalment.value := 0.0
      interest.rtprincipal.value := 0.0
      interest.rtterm.value := 0
      interest.rtintrate.value := 0.0
      interest.rloanresult.value := ""
      interest.rloanaccount.deleteallitems()
      interest.rtprincipal.setfocus
ENDCASE
RETURN nil






function pagechanged
do case
   case interest.section.value == 1
      interest.cintcomp.setFocus()
   case interest.section.value == 2
      interest.depositintcomp.setFocus()
   case interest.section.value == 3
      interest.rdepositintcomp.setFocus()
   case interest.section.value == 4
      interest.rcintcomp.setFocus()
endcase
return nil

function splashlogo
&& local iTime := Seconds()

&& Do While Seconds() - iTime < 5

&& EndDo
&& interestsplash.release
return nil


function showtext(_filename)
&& local _pointchar := at(".",_filename)
&& local _winname := ""
&& local _winwidth := getdesktopwidth() - 80
&& local _winheight := getdesktopheight() - 80
&& if _pointchar > 0
   && _winname := substr(_filename,1,_pointchar - 1)
&& else
   && _winname := _filename
&& endif
&& if iswindowdefined(&_winname)
   && release window &_winname
&& endif
&& define window &_winname at 0,0 width _winwidth height _winheight title _filename modal nosize on init textshow(_filename,_winname)
   && @ _winheight - 60,int((_winwidth - 100) / 2) button _exit1 caption "Exit" action textshowexit(_winname)
&& end window
&& center window &_winname
&& activate window &_winname
return _filename

function textshowexit(_winname)
&& release window &_winname
return _winname

function textshow(_filename,_winname)
&& local _lines := {}
&& local _handle := fopen(_filename,0)
&& local _size1 := 0
&& local _size2 := 0
&& local _sample := 0
&& local _lineNo := 0
&& local _eof1 := .f.
&& local _linestr := ""
&& local _c := ""
&& local _len1 := 0
&& local _x := 0
&& local _finished := .f.
&& local _m := 0
&& local _length1 := 0
&& local _totpages := 0
&& local _linecount := 0
&& local _length2 := 0
&& local _pageCount := 0
&& local _start := 0
&& local _end := 0
&& local _v := 0
&& local _v1 := 0
&& if _handle == -1
   && return nil
&& endif
&& _size1 := fseek(_handle,0,2)
&& _size2 := _size1
&& if _size1 > 65000
   && _sample := 65000
&& else
   && _sample := _size1
&& endif
&& fseek(_handle,0)
&& _lineNo := 1
&& aadd(_lines,"")
&& _c := space(_sample)
&& _eof1 := .f.
&& _linestr := ""
&& _len1 := 0
&& do while .not. _eof1
   && _x := 0
   && _x := fread(_handle,@_c,_sample)
   && _len1 := _len1 + _sample
   && if _x < 1
      && _eof1 := .t.
      && _lines[_lineNo] := _linestr
   && else
      && _finished := .f.
      && do while .not. _finished
         && _m := at(chr(13),_c)
         && if _m > 0
            && if _m == 1
               && _linestr := ""
               && _lineNo := _lineNo + 1
               && aadd(_lines,"")
               && _c := substr(_c,_m+1,len(_c))
            && else
               && if len(alltrim(_linestr)) > 0
                  && _linestr := _linestr + substr(_c,1,_m-1)
               && else
                  && _linestr := substr(_c,1,_m-1)
               && endif
               && _c := substr(_c,_m+1,len(_c))
               && _lines[_lineNo] := _linestr
               && _linestr := ""
               && _lineNo := _lineNo + 1
               && aadd(_lines,"")
            && endif
         && else
            && _linestr := _c
            && _finished := .t.
         && endif
      && enddo
      && _c := space(_sample)
   && endif
&& enddo
&& _tabwidth := getproperty(_winname,"WIDTH") - 50
&& _tabheight := getproperty(_winname,"HEIGHT") - 100
&& define tab _pages of &_winname at 10,10 width _tabwidth height _tabheight
&& _length1 := len(_lines)
&& if _length1 <= 100
   && _totpages := 1
&& else
   && _totpages := 0
   && _length2 := _length1
   && do while _length2 > 0
      && _length2 := _length2 - 100
      && _totpages := _totpages + 1
   && enddo
&& endif
&& for _pageCount := 1 to _totpages
   && _start := ((_pageCount-1) * 100) + 1
   && if _pageCount == _totpages
      && _end := len(_lines)
   && else
      && _end := _start + 99
   && endif
   && page "Page "+alltrim(str(_pageCount))
      && _v := "lb"+alltrim(str(_pageCount))
      && _v1 := "page"+alltrim(str(_pageCount))
      && &_v1 := {}
      && for _linecount := _start to _end
         && aadd(&_v1,{substr(_lines[_linecount],2,len(_lines[_linecount]))})
      && next _linecount
      && @ 30,15 grid &_v width _tabwidth - 30 height _tabheight - 60 headers {_filename} widths {2000} items &_v1 value 1 font "courier new" size 8 nolines
   && end page
&& next _pageCount
&& end tab
return {_filename, _winname}
