#include "minigui.ch"
#include "winprint.ch"

set procedure to "winprint.prg"

*procedure main(rysunek)
private aPrinters, printerobject,aports

HBPRN CREATE
HBPRN GET PRINTERS TO aprinters
HBPRN GET PORTS TO aports
HBPRN DELETE

        DEFINE WINDOW F1 ;
                AT 10,10 ;
                WIDTH 535 HEIGHT 290 ;
                TITLE 'HBPrinter Demo' ;
                ICON 'DEMO.ICO' ;
                MAIN ;
                FONT 'Arial' SIZE 09;
                NOSIZE


                DEFINE STATUSBAR
                        STATUSITEM '[x] Harbour Power Ready!'
                END STATUSBAR

                @10 ,10 BUTTON Button_1 CAPTION '&Print' ACTION   print()
                @50,10 BUTTON Button_2 CAPTION '&QUIT'  ACTION {|| _ReleaseWindow ("F1" )}


                
                @ 5,190 FRAME FR1 WIDTH 330 HEIGHT 90 CAPTION "Select print options"  
                @18,200 RADIOGROUP R1 OPTIONS {"Print on default printer","I select printer from dialog","Print on printer selcted below"} VALUE 1 WIDTH 300

                @100,10  LISTBOX L1 WIDTH 250 HEIGHT 100 ITEMS aprinters
                @100,270 LISTBOX L2 WIDTH 250 HEIGHT 100 ITEMS aports
		@200, 10 FRAME FR2 WIDTH 510 HEIGHT 40 CAPTION "Your choice"
                @210, 30 CHECKBOX CK1 CAPTION 'I want preview.'             width 150 value .t.
                @210,180 CHECKBOX CK2 CAPTION 'I want thumbnails.'          width 150 value .t.
                @210,330 CHECKBOX CK3 CAPTION 'No default size of preview.' width 200 value .f.

        END WINDOW

        CENTER WINDOW F1

        ACTIVATE WINDOW F1

Return Nil

return

procedure print()
LOCAL cPRN,LPREV,LR,lck

 astar:= {{0,12},{24,6},{12,24},{12,0},{24,18}}
 apoly:= {{20,30},{43,2},{12,24},{15,15},{24,18},{30,5},{20,11}}
 apoly2:={{12,2},{17,24},{25,15},{24,28},{30,25},{20,1}}

 lr:=f1.r1.value
 lprev:=f1.ck1.value

 HBPRN CREATE

 do case
    case lr==1
               if lprev
                  HBPRN SELECT DEFAULT PREVIEW
               else
                  HBPRN SELECT DEFAULT
               endif
    case lr==2
               if lprev
                  HBPRN SELECT BY DIALOG PREVIEW
               else
                  HBPRN SELECT BY DIALOG
               endif

    case lr==3
               lck:=f1.l1.value
               if lck>0
                  cprn:=aprinters[lck]
                     if lprev
                        HBPRN SELECT PRINTER cprn PREVIEW
                     else
                        HBPRN SELECT PRINTER cprn
                     endif
               else
                  msgexclamation("No printer selected","Alert")
                  return
               endif
 endcase

 if HBPRNERROR>0
    return
 endif

 if f1.ck2.value
     HBPRN ENABLE THUMBNAILS
 endif

 if f1.ck3.value
     HBPRN SET PREVIEW RECT  20,20,580,780
 endif

 HBPRN define font "f0" name "courier new" size 15 bold
 HBPRN define font "f1" name "times new roman" size 30 width 30 bold italic underline strikeout
 HBPRN define font "f2" name "times new roman" size 30 bold

 HBPRN define pen "p0" style PS_SOLID width 1 color 0x000000
 HBPRN define pen "p1" style PS_DOT width 1 color 0xFF0000
 HBPRN define pen "p2" style PS_NULL

 HBPRN define brush "b0" style BS_SOLID color 0xCCFFAA
 HBPRN define brush "b1" style BS_HATCHED color hbprncolor("yellow")  hatch HS_DIAGCROSS
 HBPRN define brush "b2" style BS_NULL

 HBPRN define elliptic region "r0" at 0 ,0 ,20,30
 HBPRN define elliptic region "r1" at 0 ,hbprnmaxcol-30,20,hbprnmaxcol
 HBPRN define elliptic region "r2" at 10,20,40,hbprnmaxcol-20
 HBPRN combine regions "r0","r1" to "r4" style WINDING
 HBPRN combine regions "r4","r2" to "r5" style WINDING

 HBPRN select font "f0"
 HBPRN select pen "p0"

 HBPRN start doc
   HBPRN set page orientation DMORIENT_PORTRAIT papersize DMPAPER_A4 font "f0"
   HBPRN start page
       @0,0,hbprnmaxrow+1,hbprnmaxcol+1 RECTANGLE pen "p1" brush "b1"
       @10,10 PICTURE "piasek.gif" size 5,5 EXTEND HBPRNMAXROW-20,HBPRNMAXCOL-20
       polygon apoly PEN "p0" BRUSH "b1"
       @5,1 say "FONT F1 BOLD ITALIC UNDERLINE STRIKEOUT 30%WIDTH" FONT "f1" TO PRINT
       @8,1 say "FONT F2 BOLD" FONT "f2" TO PRINT
   HBPRN END PAGE

   HBPRN START PAGE
    
      @25,20 SAY "Page 2 " FONT "f1" TO PRINT
     
   HBPRN END PAGE

   HBPRN SET PAGE  ORIENTATION DMORIENT_PORTRAIT PAPERSIZE DMPAPER_A4 FONT "f0"
   for i:=1 to 8
     HBPRN START PAGE
       @10,10 PICTURE "piasek.gif" size 15,15 EXTEND 35,35
       HBPRN SET TEXTCOLOR 0x00ff00
       @10,40 SAY "Page : "+str(i+2)  FONT "f1" TO PRINT
       HBPRN SET TEXTCOLOR 0xff0000
       for j:=0 to HBPRNMAXROW
           @j,5 SAY "This is a text. This is only a text."+str(j,2) TO PRINT
       next
       HBPRN SET TEXTCOLOR 0x000000
       if i%2==0
          @10,10,HBPRNMAXROW-10,HBPRNMAXCOL-10 INVERTRECT
       endif
     HBPRN END PAGE
   next

   HBPRN SET PAGE ORIENTATION DMORIENT_LANDSCAPE PAPERSIZE DMPAPER_A4 FONT "f0"

   HBPRN _MODIFY PEN "p2" STYLE PS_SOLID
   HBPRN SELECT PEN "p2"

   HBPRN SELECT FONT "f2"
   for i:=1 to 8
     HBPRN START PAGE
       HBPRN _MODIFY BRUSH "b0" COLOR if(i%2==0,0xCCFFAA,0xaaffcc)
       HBPRN _MODIFY PEN "P2" color if(i%2==0,0xff0000,0x0000ff) width 5

       @0,0,HBPRNMAXROW,HBPRNMAXCOL RECTANGLE PEN "p2" BRUSH "b0"

       HBPRN SET TEXTCOLOR 0x0000ff
       @10,50 SAY "Page : "+str(i+10) FONT "f2" TO PRINT
       HBPRN SET TEXTCOLOR 0xFF0000

       for j:=1 to 10
         if j%2==0
            HBPRN _MODIFY FONT "F2" size 45 nobold noitalic nounderline nostrikeout
         else
            HBPRN _MODIFY FONT "F2" size 45 bold italic underline strikeout angle 10 width 50
         endif
         @j*3,5 SAY "This is a text. This is only a text." FONT "f2" TO PRINT
       next

       if i%2==0
         @10,10,HBPRNMAXROW-10,HBPRNMAXCOL-10 INVERTRECT
       endif

     HBPRN END PAGE
   next

 HBPRN END DOC
 
 HBPRN DELETE

return
