#include "minigui.ch"
#include "winprint.ch"

set procedure to "winprint.prg"
a := {{1,"Rathinagiri",1000,100,100,100},;
      {2,"Rathinagiri",200,1000,100,100},;
      {3,"Rathinagiri",300,100,1000,100},;
      {4,"Rathinagiri",400,100,100,1000},;
      {5,"Rathinagiri",600,100,100,100},;
      {6,"Rathinagiri",700,100,10000,100},;
      {7,"Rathinagiri",400,100,100,100},;
      {8,"Rathinagiri",700,10000,100,100},;
      {9,"Rathinagiri",800,100,100,100},;
      {10,"Rathinagiri",80000,100,100,100}}

define window giri at 0,0 width 800 height 600 main
   define button b1
      row 10
      col 10
      caption "Print"
      action print1()
   end button
end window
center window giri
activate window giri

function print1
hbprn create
HBPRN select by dialog preview
hbprn set preview rect 10,10,800,1000
hbprn define font "f1" name "Arial" size 20
hbprn select font "f1"
hbprn start doc
   hbprn set page orientation DMORIENT_PORTRAIT papersize DMPAPER_A4 font "f1"
   hbprn start page
      row := 4
      i := 1      
      @ row,0 say "------------------------------------------------------" font "f1" to print
      row := row + 1
      @ row,0 say "Sl.No.   Name             Tamil  English Maths Science" font "f1" to print
      row := row + 1
      @ row,0 say "------------------------------------------------------" font "f1" to print
      row := row + 1
      for n := row to hbprnmaxrow - 5
         printline(n,0,{str(a[i,1],3,0),;
                       a[i,2],;
                       str(a[i,3],6,0),;
                       str(a[i,4],6,0),;
                       str(a[i,5],6,0),;
                       str(a[i,6],6,0)},;
                       {{1,.f.,.f.,.f.,.f.},;
                       {0,.t.,.f.,.f.,.f.},;
                       {1,.f.,.t.,.f.,.f.},;
                       {1,.f.,.f.,.t.,.f.},;
                       {1,.f.,.f.,.f.,.f.},;
                       {1,.f.,.f.,.f.,.t.}},"f1")
         i++
         if i == len(a)
            n := hbprnmaxrow
         endif   
      next n
   hbprn end page
hbprn end doc
hbprn delete
return nil         


function printline(row,col,aitems,aattrib,currentfont)
local tempcol := 0
local i := 0
/*
if type(row) <> "N" .or. type(col) <> "N" .or. type(aitems) <> "A" .or. type(aattrib) <> "A"
   msginfo("Wrong arguments")
   return nil
endif
*/
if len(aitems) <> len(aattrib)
   msginfo("Attributes not given properly. {njustify,lbold,litalic,lunderline,lstrikeout}")
endif
if len(aattrib[1]) <> 5
   msginfo("Attributes not given properly. {njustify,lbold,litalic,lunderline,lstrikeout}")
endif   
tempcol := col
hbprn get text align to oldstyle
for i := 1 to len(aitems)
   njustify := aattrib[i,1]
   lbold := aattrib[i,2]
   litalic := aattrib[i,3]
   lunderline := aattrib[i,4]
   lstrikeout := aattrib[i,5]
   do case
      case njustify == 0
         hbprn set text align left
      case njustify == 1
         hbprn set text align right
         tempcol := tempcol + len(aitems[i])
      case njustify == 2
         hbprn set text align center
   end case
   hbprn:modifyfont(currentfont,,,,,lbold,litalic,lunderline,lstrikeout)
   @ row,tempcol say aitems[i] font currentfont to print
   tempcol := tempcol + len(aitems[i])
next i
hbprn set text align oldstyle
return nil       